CREATE OR REPLACE PROCEDURE shanglifeecif.init_insurancearrangement() -- 洢
IS    
BEGIN
	--policy_information ±
	shanglifeecif.init_insurancearrangement_policy_information();

	--health_insurance_listing ֶ
	shanglifeecif.up_insurancearrangement_health_insurance_listing();

	--ֶ 
	shanglifeecif.up_insurancearrangement_other();
END;



/

CREATE OR REPLACE PROCEDURE shanglifeecif.init_insurancearrangement_policy_information() -- 洢
IS    
BEGIN

INSERT INTO shanglifeecif.insurancearrangement(
  iaid ,--'ID', 
  policyno ,-- 'յ INSURANCEINFO.CONTNO', 
  pindate ,-- ' POLICY_INFORMATION.CVALIDATE', 
  pmdate ,-- 'ձ POLICY_INFORMATION.ENDDATE', 
  norenewal ,-- ' POLICY_INFORMATION.PAYCOUNT', 
  payment ,-- 'ɷѷʽ POLICY_INFORMATION.PAYINTV', 
  applicantscustid ,-- 'Ͷ οͻţҵindividualid', 
  appname ,-- 'Ͷ POLICY_INFORMATION.NAME', 
  appcertid ,-- 'Ͷ֤ POLICY_INFORMATION.IDNO', 
  insuredscustid ,-- ' οͻ', 
  insname ,-- ' POLICY_INFORMATION.INSUREDNAME', 
  inscertid ,-- '֤ POLICY_INFORMATION.INSUREDIDNO', 
  productid ,-- 'ִ POLICY_INFORMATION.RISKCODE', 
  productname,--
  policybelong ,-- 'ҵ POLICY_INFORMATION.SALECOM',  
  payendyear ,-- 'ɷ POLICY_INFORMATION.PAYENDYEAR', 
  policystate,--״̬
  prem,--
  Risk,--
  NPDate,--´νɷ
  PADate,--Ͷ
  AgentOrg,--
  schannel,--
  PWComp,--бֹ˾
  agrmntage ,--
  created_by ,-- '', 
  created_time -- 'ʱ', 

) 
SELECT 
	row_number()over(),
	CONTNO,--policyno ,-- 'յ INSURANCEINFO.CONTNO', 
	CVALIDATE,--pindate ,-- ' POLICY_INFORMATION.CVALIDATE', 
	ENDDATE,--pmdate ,-- 'ձ POLICY_INFORMATION.ENDDATE', 
	PAYCOUNT,--norenewal ,-- ' POLICY_INFORMATION.PAYCOUNT', 
	PAYINTV,--payment ,-- 'ɷѷʽ POLICY_INFORMATION.PAYINTV', 
	CUSTOMERNO,--applicantid ,-- 'Ͷ POLICY_INFORMATION.CUSTOMERNOindividualοͻţҵindividualid', 
	NAME,--appname ,-- 'Ͷ POLICY_INFORMATION.NAME', 
	IDNO,--appcertid ,-- 'Ͷ֤ POLICY_INFORMATION.IDNO', 
	insuredno,--insuredid ,-- ' insuredno', 
	INSUREDNAME,--insname ,-- ' POLICY_INFORMATION.INSUREDNAME', 
	INSUREDIDNO,--inscertid ,-- '֤ POLICY_INFORMATION.INSUREDIDNO', 
	RISKCODE,--productid ,-- 'ִ POLICY_INFORMATION.RISKCODE', 
	RISKNAME, --productname 
	SALECOM,--policybelong ,-- 'ҵ POLICY_INFORMATION.SALECOM', 
	PAYENDYEAR,--payendyear ,-- 'ɷ POLICY_INFORMATION.PAYENDYEAR', 
	APPFLAG, --״̬
	prem,--
	AMNT,--
	PAYTODATE,--´νɷ
	CUSTOMGETPOLDATE,--Ͷ
	AGENTCOM,--
	SALECHNL,--
	"ϺϺֹ˾",
	case
		when security ='' then 42720
		when security = '100' then 36500
		when security = '80' then 29200
		when security = '70' then 25550
		when security = '70' then 25550
		when security = '65' then 23725
		when security = '60' then 21900
		when security = '30' then 10950
		when security = '20' then 7300
		when security = '10' then 3650
		when security = '6' then 2190
		when security = '5' then 1825
		when security = '1' then 365
		when security = '180' then 180
		when security = '6' then 180
		when security = '90' then 90
		when security = '3' then 90
		when security = '1' then 30
		when security = '30' then 30
		when security = '15' then 15
		when security = '7' then 7
	end,
	'admin',
	sysdate() 
	FROM shanghailifeecif.policy_information 
	
	--Ͷ˺ͱid  Ϊ scustidظҪȥ

	UPDATE shanglifeecif.insurancearrangement a SET (
		applicantid --'ͶID',
	) = (
	   select
	   	c.indid
	   from (
		   	select
				row_number()over(PARTITION BY b.scustid) rn,
				b.indid,
				b.scustid
			from shanglifeecif.individual b
	   ) c
	   WHERE c.scustid  = a.applicantscustid and c.rn=1
	) WHERE 1=1 ;


	UPDATE shanglifeecif.insurancearrangement a SET (
		insuredid --'ͶID',
	) = (
	   select
	   	c.indid
	   from (
		   	select
				row_number()over(PARTITION BY b.scustid) rn,
				b.indid,
				b.scustid
			from shanglifeecif.individual b
	   ) c
	   WHERE c.scustid  = a.insuredscustid and c.rn=1
	) WHERE 1=1 ;

	--INSURANCEINFO еϢ

	UPDATE shanglifeecif.insurancearrangement a SET (
		pano ,-- 'Ͷ INSURANCEINFO.PRTNO',  
		pisdate ,-- 'ǩ INSURANCEINFO.SIGNDATE', 
		padate ,-- 'Ͷ INSURANCEINFO.POLAPPLYDATE', 
		policystate ,--INSURANCEINFO,appflag
		prem ,-- 'ܱ INSURANCEINFO.PREM', 
		productname ,-- '	 INSURANCEINFO.RISKNAME'
		agentchannel -- ' INSURANCEINFO.SELLTYPE', 
	) = (
		select
			PRTNO,--pano ,-- 'Ͷ INSURANCEINFO.PRTNO',  
			SIGNDATE,--pisdate ,-- 'ǩ INSURANCEINFO.SIGNDATE', 
			POLAPPLYDATE,--padate ,-- 'Ͷ INSURANCEINFO.POLAPPLYDATE', 
			appflag,--policystate ,--INSURANCEINFO,appflag
			PREM,--prem ,-- 'ܱ INSURANCEINFO.PREM', 
			RISKNAME,--productname ,-- '	 INSURANCEINFO.RISKNAME'
			SELLTYPE--agentchannel ,-- ' INSURANCEINFO.SELLTYPE', 
		from shanghailifeecif.INSURANCEINFO b
		where b.contno  = a.policyno
	) WHERE 1=1 ;

END;
/

CREATE OR REPLACE PROCEDURE shanglifeecif.update_risk_categories() -- 洢
IS    
BEGIN
--ִ
	UPDATE shanglifeecif.insurancearrangement a SET (
		risk_categories,
		risk_categories_name
	) = (
		
		select
				b.kindcode,
				(CASE b.kindcode 
					WHEN 'A' THEN '˺' 
					WHEN 'U' THEN 'ܱ' 
					WHEN 'R' THEN '' 
					WHEN 'S' THEN 'ؼ' 
					WHEN 'L' THEN 'ٱ' 
					WHEN 'H' THEN '' 
				END) AS kindname
			from lmriskapp b WHERE a.productid = b.riskcode
	
	) WHERE 1=1;

END;

--ʱ

CREATE TABLE shanglifeecif.insurancearrangement_health_tmp(
    id string,
    orderid string  DEFAULT NULL COMMENT 'ڷ',
    contno string DEFAULT NULL COMMENT '',
  	AGENTGROUP string DEFAULT NULL COMMENT 'бֹ˾',--pwcomp ,-- 'бֹ˾ HEALTH_INSURANCE_LISTING.AGENTGROUPAREA ӪҵHEALTH_INSURANCE_LISTING.AGENTGROUP Ӫҵ', 
	SALECHANNELS string DEFAULT NULL COMMENT '',--schannel ,-- ' HEALTH_INSURANCE_LISTING.SALECHANNELS 1 2 3 4 5',
	AMNT string DEFAULT NULL COMMENT 'ܱ',--risk ,-- 'ܱ HEALTH_INSURANCE_LISTING.AMNT(ԻУ˱磺POLICY_INFORMATIONINSURANCEINFO ȱһ)', 
	AGENTCODE  string DEFAULT NULL COMMENT'ҵԱ'--spname ,-- 'ҵԱ HEALTH_INSURANCE_LISTING.AGENTCODE', 
) COMMENT 'ճб嵥 ʱ '
STORED AS ES
with shard number 10
replication 1;


CREATE OR REPLACE PROCEDURE shanglifeecif.up_insurancearrangement_health_insurance_listing() -- 洢
IS    
BEGIN
	--ʱ
	delete from shanglifeecif.insurancearrangement_health_tmp;

	--ʼʱ
	insert into shanglifeecif.insurancearrangement_health_tmp (
		id,
		orderid,
		contno,
		agentgroup,
		SALECHANNELS,
		AMNT,
		AGENTCODE
	) select 
		row_number()over(),
		row_number()over(PARTITION BY contno),
		contno,
		agentgroup,
		SALECHANNELS,
		AMNT,
		AGENTCODE
	from shanghailifeecif.HEALTH_INSURANCE_LISTING

	--ʱinsurancearrangement 
	UPDATE shanglifeecif.insurancearrangement a SET (
		pwcomp ,-- 'бֹ˾ HEALTH_INSURANCE_LISTING.AGENTGROUPAREA ӪҵHEALTH_INSURANCE_LISTING.AGENTGROUP Ӫҵ', 
		schannel ,-- ' HEALTH_INSURANCE_LISTING.SALECHANNELS 1 2 3 4 5',
		risk ,-- 'ܱ HEALTH_INSURANCE_LISTING.AMNT(ԻУ˱磺POLICY_INFORMATIONINSURANCEINFO ȱһ)', 
		spname -- 'ҵԱ HEALTH_INSURANCE_LISTING.AGENTCODE', 
	) = (
		select
			b.AGENTGROUP,--pwcomp ,-- 'бֹ˾ HEALTH_INSURANCE_LISTING.AGENTGROUPAREA ӪҵHEALTH_INSURANCE_LISTING.AGENTGROUP Ӫҵ', 
			b.SALECHANNELS,--schannel ,-- ' HEALTH_INSURANCE_LISTING.SALECHANNELS 1 2 3 4 5',
			b.AMNT,--risk ,-- 'ܱ HEALTH_INSURANCE_LISTING.AMNT(ԻУ˱磺POLICY_INFORMATIONINSURANCEINFO ȱһ)', 
			b.AGENTCODE--spname ,-- 'ҵԱ HEALTH_INSURANCE_LISTING.AGENTCODE', 
		from shanglifeecif.insurancearrangement_health_tmp b
		where b.contno  = a.policyno
		and b.orderid = 1
	) WHERE 1=1 ;


END;

/
CREATE OR REPLACE PROCEDURE shanglifeecif.up_insurancearrangement_other() -- 洢
IS    
BEGIN
	


	UPDATE shanglifeecif.insurancearrangement a SET (
		policytype  -- '', 
	) = (
	   select
	   	c.CONTTYPE
	   from (
		   	select
				row_number()over(PARTITION BY b.contno) rn,
				b.CONTTYPE,
				b.contno
			from shanghailifeecif.PERSONAL_INSURANCE b
	   ) c
	   WHERE c.contno  = a.policyno and c.rn=1
	) WHERE 1=1 ;

	UPDATE shanglifeecif.insurancearrangement a SET (
		poservice	  -- 'Ƿȫ', 
	) = (
	   SELECT
	   	IF(count(b.CONTNO) >0,1,0)
	   FROM shanghailifeecif.AUDIT_EDORLIST b
	   where b.contno  = a.policyno
	) WHERE 1=1 ;


	UPDATE shanglifeecif.insurancearrangement a SET (
		soinsured-- '', 
	) = (
	   SELECT
	   		PEOPLES3
	   FROM shanghailifeecif.HEALTH_GROUP_LISTING b
	   where b.contno  = a.policyno
	) WHERE 1=1 ;

END;